<template>
  <div>
    <el-alert
      v-show="errorMessage"
      :title="errorMessage.title"
      @close="error = {}"
      type="error">
      <li v-if="errorMessage.missingFields && errorMessage.missingFields.length > 0">
        ${{$t('validation.missingFields', {missingFields: errorMessage.missingFields})}}
      </li>
      <li v-for="(message, index) in errorMessage.other" :key="index">
        {{message}}
      </li>
    </el-alert>
  </div>
</template>

<script>

export default {
  props: {
    error: {
      type: Object,
      default: () => {
        return {}
      }
    }
  },
  methods: {
    isValidationError: function () {
      return this.error.name && this.error.name === 'ValidationError'
    }
  },
  computed: {
    errorMessage: function () {
      if (this.error.name && this.error.name === 'ValidationError') {
        console.log('in here');
        return {
          title: this.$t('validation.validationFailed'),
          missingFields: Object.keys(this.error.errors).map((currentError) => {

            if (currentError.kind === 'required') {
              return $t('formFields.' + errorDetails.path)
            }
          }),
          other: this.error.errors.map((currentError) => {
            if (currentError.kind !== 'required') {
              return $t(currentError.message)
            }
          })
        }
      } else {
        return {
          title: this.error.message
        }
      }
    }
  }
}
</script>
